/* 
 * enCore 
 * Eneso Tecnología de Adaptación, S.L. 
 */


#ifndef __DRAW_H__
#define __DRAW_H__

#include <cairo.h>
#include <glib.h>

typedef enum
{
	TEXT_ALIGN_LEFT,
	TEXT_ALIGN_RIGHT,
	TEXT_ALIGN_CENTER
}
TextAlign;

void 
draw_text (cairo_t* cr, gint x, gint y, const gchar* text, const gchar* font, TextAlign align);
void 
draw_text_adjust (cairo_t* cr, gint x, gint y, gint max_width, const gchar* text, const gchar* font);
void
draw_text_multiline (cairo_t* cr, gint x, gint y, const gchar* text,
		const gchar* font, gint text_width, gboolean center_y);

void
draw_round_rect (cairo_t* cr, gint x, gint y, gint width, gint height, gint radius);

#endif	/* __DRAW_H__ */
