/* 
 * enCore
 * Eneso Tecnología de Adaptación, S.L. 
 */

#include <gtk/gtk.h>
#include <glib/gi18n.h>
#include <stdio.h>
#include "ehid.h"
#include "misc.h"
#include "protocol.h"
#include "window.h"
#include "encore.h"

Action	switch_action [N_SWITCHES] =
{
	{ MOUSE_ACTION,		MOUSE_LEFT_CLICK,		0,	TRUE },
	{ MOUSE_ACTION,		MOUSE_RIGHT_CLICK,		0,	TRUE },
	{ MOUSE_ACTION,		MOUSE_DOUBLE_CLICK,		0,	TRUE },
	{ MOUSE_ACTION,		MOUSE_DRAG_DROP,		0,	TRUE },
	{ MOUSE_MOV_ACTION,	MOV_UP,					0,	TRUE },
	{ MOUSE_MOV_ACTION,	MOV_DOWN,				0,	TRUE },
	{ MOUSE_MOV_ACTION,	MOV_RIGHT,				0,	TRUE },
	{ MOUSE_MOV_ACTION,	MOV_LEFT,				0,	TRUE }
};

gint	mouse_speed [3] = { 5, 18, 7 };
gint	mouse_stretch [2] = { 40, 150 };
gint	joy_displacement = 115;

gboolean 	device_connected 	= FALSE;

static void 
handle_config_switch	(gchar* message, gint n_bytes);
static void 
handle_config_param		(gchar* message, gint n_bytes);



	void
send_command (gchar command, gchar p1, gchar p2, gchar p3, gchar p4, gchar p5, gchar p6)
{
	static gchar buffer [9] = { 0, 0, 0, 0, 0, 0, 0, 0, 0 };

	buffer [0] = command;
	buffer [1] = p1;
	buffer [2] = p2;
	buffer [3] = p3;
	buffer [4] = p4;
	buffer [5] = p5;
	buffer [6] = p6;

	ehid_send (buffer);
}

	void
handle_message (gchar* message, guint n_bytes)
{
	switch (message [0])
	{
		case NOTIF_CONFIG_SWITCH: 
			handle_config_switch (message, n_bytes); 
			break;
		case NOTIF_CONFIG_PARAM:
			handle_config_param (message, n_bytes); 
			break;
		case NOTIF_GENERIC_EVENT:
			g_print ("Generic event: %02X %s\n", message [1],
					message [2] == GENERIC_PRESS ? "press" : "release");
			break;
		default: break;
	}
}

	static void
handle_config_switch (gchar* message, gint n_bytes)
{
	gint	sw;

	sw = message [2];

	switch_action [sw].type = message [3];
	switch_action [sw].action = message [4];
	switch_action [sw].modifiers = message [5];
	switch_action [sw].auto_release = message [6];

	update_config_widgets ();
}

	static void
handle_config_param (gchar* message, gint n_bytes)
{
	gint	i;

	for (i = 0; i < 3; i++)
		mouse_speed [i] = message [i + 2];

	for (i = 0; i < 2; i++)
		mouse_stretch [i] = message [i + 5];

	joy_displacement = message [7];

	update_config_widgets ();

	dialog_info ("enCore", _("Read successfully. Current configuration of the device is shown."));
}
