/* 
 * enCore
 * Eneso Tecnologa de Adaptacin, S.L. 
 */

#ifndef __PROTOCOL_H__
#define __PROTOCOL_H__

/* Commands from the application */
#define COMMAND_CONFIG_SWITCH	4			
#define COMMAND_CONFIG_PARAM	7
#define COMMAND_SAVE			8
#define COMMAND_SEND			9
#define COMMAND_BOOTLOADER		10

#define SWITCH					0
#define PARAM					1

/* Action type */
#define MOUSE_ACTION			0
#define KEYBOARD_ACTION			1
#define JOYSTICK_ACTION			2
#define MOUSE_MOV_ACTION		3
#define JOYSTICK_MOV_ACTION		4
#define GENERIC_ACTION			5

/* Mouse action */
#define MOUSE_LEFT_CLICK		0
#define MOUSE_RIGHT_CLICK		1
#define MOUSE_DOUBLE_CLICK		2
#define MOUSE_DRAG_DROP			3

/* Mouse & joystick movement */
#define MOV_RIGHT				1
#define MOV_LEFT				2
#define MOV_UP					4
#define MOV_DOWN				8

/* Notifications to the application */
#define NOTIF_CONFIG_SWITCH		9
#define NOTIF_CONFIG_PARAM		10
#define NOTIF_GENERIC_EVENT		100

/* Generic event type */
#define GENERIC_PRESS			0
#define GENERIC_RELEASE			1

#endif /* __PROTOCOL_H__ */
